{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}

module Rewriting.Curry_Substitution
  ( C_Subst
  , d_C_showSubst
  , nd_C_showSubst
  , d_C_emptySubst
  , nd_C_emptySubst
  , d_C_extendSubst
  , nd_C_extendSubst
  , d_C_lookupSubst
  , nd_C_lookupSubst
  , d_C_applySubst
  , nd_C_applySubst )
  where

import Basics
import qualified Curry_FiniteMap
import qualified Curry_Prelude
import qualified Rewriting.Curry_Term


type C_Subst t0 = Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)

d_C_showSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_C_showSubst cd cs = Curry_Prelude.d_OP_dot Curry_Prelude.d_C_unlines
  (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_map
  d_OP_showSubst_dot_showOne_dot_2) Curry_FiniteMap.d_C_fmToList cd cs) cd cs

nd_C_showSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)
nd_C_showSubst s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
  Curry_Prelude.d_C_unlines) (Curry_Prelude.nd_OP_dot (wrapNX id
  (Curry_Prelude.nd_C_map (wrapDX id d_OP_showSubst_dot_showOne_dot_2))) (wrapNX
  id Curry_FiniteMap.nd_C_fmToList) s0 cd cs) s1 cd cs))

d_OP_showSubst_dot_showOne_dot_2 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Curry_Prelude.OP_Tuple2 t0 t1 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_showSubst_dot_showOne_dot_2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_show x2 cd cs) (Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.toCurryString " -> ") (Curry_Prelude.d_C_show x3 cd cs) cd
    cs) cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_showSubst_dot_showOne_dot_2 l cd cs) (d_OP_showSubst_dot_showOne_dot_2
    r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_showSubst_dot_showOne_dot_2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c
    (d_OP_showSubst_dot_showOne_dot_2 e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Rewriting.Substitution.showSubst.showOne.2" [show x1] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.showSubst.showOne.2"
    (showCons x1))

d_C_emptySubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_emptySubst cd cs = Curry_FiniteMap.d_C_emptyFM (acceptCs id
  Curry_Prelude.d_OP_lt) cd cs

nd_C_emptySubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)
nd_C_emptySubst s cd cs = let s0 = s
  in s0 `seq` Curry_FiniteMap.nd_C_emptyFM (wrapDX (wrapDX id) (acceptCs id
  Curry_Prelude.d_OP_lt)) s0 cd cs

d_C_extendSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0 -> Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
d_C_extendSubst cd cs = acceptCs (acceptCs id) Curry_FiniteMap.d_C_addToFM

nd_C_extendSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) (Func Curry_Prelude.C_Int (Func
  (Rewriting.Curry_Term.C_Term t0) (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0))))
nd_C_extendSubst s cd cs = wrapDX (wrapDX (wrapNX id)) (acceptCs (acceptCs id)
  Curry_FiniteMap.nd_C_addToFM)

d_C_lookupSubst :: forall t0 . (Curry_Prelude.Curry t0) => Cover -> ConstStore
  -> Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Cover -> ConstStore -> Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Rewriting.Curry_Term.C_Term t0)
d_C_lookupSubst cd cs = acceptCs id Curry_FiniteMap.d_C_lookupFM

nd_C_lookupSubst :: forall t0 . (Curry_Prelude.Curry t0) => IDSupply -> Cover
  -> ConstStore -> Func (Curry_FiniteMap.C_FM Curry_Prelude.C_Int
  (Rewriting.Curry_Term.C_Term t0)) (Func Curry_Prelude.C_Int
  (Curry_Prelude.C_Maybe (Rewriting.Curry_Term.C_Term t0)))
nd_C_lookupSubst s cd cs = wrapDX (wrapNX id) (acceptCs id
  Curry_FiniteMap.nd_C_lookupFM)

d_C_applySubst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Rewriting.Curry_Term.C_Term t0 -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0
d_C_applySubst x1 x2 cd cs = case x2 of
  Rewriting.Curry_Term.C_TermVar x3 -> Curry_Prelude.d_C_maybe x2
    Curry_Prelude.d_C_id (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (d_C_lookupSubst cd cs) x1 cd cs) x3 cd cs) cd cs
  Rewriting.Curry_Term.C_TermCons x4 x5 -> Rewriting.Curry_Term.C_TermCons x4
    (Curry_Prelude.d_C_map (d_C_applySubst x1) x5 cd cs)
  Rewriting.Curry_Term.Choice_C_Term d i l r -> narrow d i (d_C_applySubst x1 l
    cd cs) (d_C_applySubst x1 r cd cs)
  Rewriting.Curry_Term.Choices_C_Term d i xs -> narrows cs d i (\z ->
    d_C_applySubst x1 z cd cs) xs
  Rewriting.Curry_Term.Guard_C_Term d c e -> guardCons d c (d_C_applySubst x1 e
    cd $! addCs c cs)
  Rewriting.Curry_Term.Fail_C_Term d info -> failCons d (traceFail
    "Rewriting.Substitution.applySubst" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.applySubst" (showCons x2))

nd_C_applySubst :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0)
  -> Rewriting.Curry_Term.C_Term t0 -> IDSupply -> Cover -> ConstStore
  -> Rewriting.Curry_Term.C_Term t0
nd_C_applySubst x1 x2 s cd cs = case x2 of
  Rewriting.Curry_Term.C_TermVar x3 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_maybe x2 (wrapDX id
    Curry_Prelude.d_C_id) (let s3 = leftSupply s4
                               s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (nd_C_lookupSubst s0 cd cs)
    x1 s1 cd cs)) x3 s3 cd cs)) s5 cd cs))
  Rewriting.Curry_Term.C_TermCons x4 x5 -> let s0 = s
    in s0 `seq` Rewriting.Curry_Term.C_TermCons x4 (Curry_Prelude.nd_C_map
    (wrapNX id (nd_C_applySubst x1)) x5 s0 cd cs)
  Rewriting.Curry_Term.Choice_C_Term d i l r -> narrow d i (nd_C_applySubst x1 l
    s cd cs) (nd_C_applySubst x1 r s cd cs)
  Rewriting.Curry_Term.Choices_C_Term d i xs -> narrows cs d i (\z ->
    nd_C_applySubst x1 z s cd cs) xs
  Rewriting.Curry_Term.Guard_C_Term d c e -> guardCons d c (nd_C_applySubst x1 e
    s cd $! addCs c cs)
  Rewriting.Curry_Term.Fail_C_Term d info -> failCons d (traceFail
    "Rewriting.Substitution.applySubst" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.applySubst" (showCons x2))

d_C_substituteSingle :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)
d_C_substituteSingle x1 x2 cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> Curry_Prelude.OP_Tuple2 (d_C_applySubst x1 x3
    cd cs) (d_C_applySubst x1 x4 cd cs)
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (d_C_substituteSingle x1
    l cd cs) (d_C_substituteSingle x1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_C_substituteSingle x1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (d_C_substituteSingle x1
    e cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Rewriting.Substitution.substituteSingle" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.substituteSingle" (showCons
    x2))

nd_C_substituteSingle :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_FiniteMap.C_FM Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term
  t0) -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)
nd_C_substituteSingle x1 x2 s cd cs = case x2 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.OP_Tuple2 (nd_C_applySubst x1 x3 s0 cd
    cs) (nd_C_applySubst x1 x4 s1 cd cs)))
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i (nd_C_substituteSingle x1
    l s cd cs) (nd_C_substituteSingle x1 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_C_substituteSingle x1 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c (nd_C_substituteSingle x1
    e s cd $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Rewriting.Substitution.substituteSingle" [show x1, show x2] info)
  _ -> failCons cd (consFail "Rewriting.Substitution.substituteSingle" (showCons
    x2))

d_C_substitute :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term
  t0) (Rewriting.Curry_Term.C_Term t0))
d_C_substitute x1 x2 cd cs = Curry_Prelude.d_C_map (d_C_substituteSingle x1) x2
  cd cs

nd_C_substitute :: forall t0 . (Curry_Prelude.Curry t0) => Curry_FiniteMap.C_FM
  Curry_Prelude.C_Int (Rewriting.Curry_Term.C_Term t0) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term t0)
  (Rewriting.Curry_Term.C_Term t0)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Rewriting.Curry_Term.C_Term
  t0) (Rewriting.Curry_Term.C_Term t0))
nd_C_substitute x1 x2 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_map (wrapNX id (nd_C_substituteSingle x1)) x2
  s0 cd cs

